freeslot("S_STEALTH_DIVE","SKINCOLOR_STEALTH")
states[S_STEALTH_DIVE] = {SPR_PLAY, SPR2_SWIM, 26, nil, 0, 0, S_PLAY_FALL}

sfxinfo[sfx_alart] = {
	singular = false,
	caption = "Mimmicking Skip."
}

skincolors[SKINCOLOR_STEALTH] = {
	name = "Stealth",
	ramp = {123,123,123,124,124,124,124,125,125,125,126,126,126,126,127,127},
	invcolor = SKINCOLOR_SANDY,
	invshade = 1, 
	chatcolor = V_AQUAMAP,
	accessible = true
}

addHook("PostThinkFrame", function(player)
	for player in players.iterate
		if player.mo.skin == "stealth" then
			player.mo.frame = $|TR_TRANS30|FF_FULLBRIGHT
			if player.followmobj
				player.followmobj.frame = $|TR_TRANS30|FF_FULLBRIGHT
			end
		end
	end
end)

addHook("PlayerThink", function(player)	
	if player.mo.skin == "stealth"
	and player.teleportready == nil
		player.teleportready = false
	end
	if player.mo.skin == "stealth"
	and P_IsObjectOnGround(player.mo)
		player.teleportready = false
	end
	if player.mo.skin == "stealth"
	and player.jumpdown == nil
		player.jumpdown = 0
	end
	if not (player.cmd.buttons & BT_CUSTOM1)
	and player.mo.skin == "stealth"
		player.jumpdown = 0
	end
end)

//addHook("AbilitySpecial", function(player)
//changing this to the spin key
addHook("PlayerThink", function(player)	
	if player.mo.skin == "stealth"
	and (player.pflags & PF_JUMPED)
	and (player.cmd.buttons & BT_CUSTOM1)
	and player.teleportready == false
	and player.jumpdown == 0
	and not player.tiny == true
	and not (player.playerstate == PST_DEAD)
		player.teleportready = true
		player.jumpdown = 1
		S_StartSound(player.mo, sfx_alart)
		player.mo.state = S_STEALTH_DIVE
		P_SetObjectMomZ(player.mo,9*FRACUNIT)
		P_InstaThrust(player.mo,player.mo.angle,19*FRACUNIT/3 + player.speed)
		for i = 1,18
		local dust = P_SPMAngle(player.mo,MT_SPINDUST,player.mo.angle+(ANG20*i),1)
		P_SetObjectMomZ(dust, 0, false)
		P_InstaThrust(dust,dust.angle,14*FRACUNIT)
		end
	end
end)

//addHook("AbilitySpecial", function(player)
addHook("PlayerThink", function(player)	
	if player.mo.skin == "stealth"
	and (player.cmd.buttons & BT_CUSTOM1)
	and player.teleportready == true
	and not (player.pflags & PF_THOKKED)
	and player.jumpdown == 0
	and not player.tiny == true
	and not (player.playerstate == PST_DEAD)
		player.teleportready = false
		player.pflags = $ |PF_THOKKED
		local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = player.mo.color
		ghost.colorized = true
		ghost.fuse = 15
		ghost.scale = player.mo.scale*3/2
		S_StartSound(player.mo, sfx_s3kb3)
		player.mo.state = S_PLAY_FALL
		P_InstaThrust(player.mo,player.mo.angle,5*FRACUNIT + player.speed)
		player.camangle = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
		local gotox = player.mo.x+FixedMul(260*FRACUNIT, cos(player.camangle))
		local gotoy = player.mo.y+FixedMul(260*FRACUNIT, sin(player.camangle)) 
		//local gotoz = player.mo.z+FixedMul(1*FRACUNIT/3, sin(player.camangle)) 
		P_TeleportMove(player.mo, gotox, gotoy, player.mo.z)
		P_SetObjectMomZ(player.mo,0)
		local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = ColorOpposite(player.mo.color)
		ghost.colorized = true
		ghost.fuse = 15
		ghost.scale = player.mo.scale*3/2
	end
end)

//oh god not again
addHook("PlayerThink", function(player)
	if player.mo.valid and (player.mo.skin == "stealth")
	and (player.powers[pw_super])
		player.pflags = $1 | PF_GODMODE
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.valid and (player.mo.skin == "stealth")
	and (player.pflags & PF_FULLSTASIS)
		player.pflags = $ & ~(PF_FULLSTASIS)
	end
end)

addHook("PostThinkFrame", function(player)
	for player in players.iterate
		if player.mo.skin == "stealth"
		and (player.pflags & PF_THOKKED) then
			player.mo.frame = $|TR_TRANS50|FF_SEMIBRIGHT
			if player.followmobj
				player.followmobj.frame = $|TR_TRANS50|FF_SEMIBRIGHT
			end
		end
	end
end)

//trying to find a way to stop him from getting stuck in the ground
addHook("PlayerThink", function(player)	
	if player.mo.skin == "stealth"
	and player.tiny == nil
		player.tiny = false
	end
	if player.mo.skin == "stealth"
	and (player.cmd.buttons & BT_CUSTOM2)
		player.tiny = true
	end
	if player.mo.skin == "stealth"
	and (player.cmd.buttons & BT_CUSTOM3)
		player.tiny = false
	end
end)

addHook("PlayerThink", function(player)	
	if player.mo.skin == "stealth" and (player.tiny == true) then
		player.mo.scale = 18*FRACUNIT/100
	else
		player.mo.scale = FRACUNIT
	end
end)

//abilities changed for when he smol
addHook("PlayerThink", function(player)	
	if player.mo.skin == "stealth"
	and (player.pflags & PF_JUMPED)
	and (player.cmd.buttons & BT_CUSTOM1)
	and player.teleportready == false
	and player.jumpdown == 0
	and player.tiny == true
		player.teleportready = true
		player.jumpdown = 1
		S_StartSound(player.mo, sfx_alart)
		player.mo.state = S_STEALTH_DIVE
		P_SetObjectMomZ(player.mo,9*FRACUNIT/10)
		P_InstaThrust(player.mo,player.mo.angle,19*FRACUNIT/13 + player.speed)
		for i = 1,18
		local dust = P_SPMAngle(player.mo,MT_SPINDUST,player.mo.angle+(ANG20*i),1)
		P_SetObjectMomZ(dust, 0, false)
		P_InstaThrust(dust,dust.angle,14*FRACUNIT)
		end
	end
end)

//addHook("AbilitySpecial", function(player)
addHook("PlayerThink", function(player)	
	if player.mo.skin == "stealth"
	and (player.cmd.buttons & BT_CUSTOM1)
	and player.teleportready == true
	and not (player.pflags & PF_THOKKED)
	and player.jumpdown == 0
	and player.tiny == true
		player.teleportready = false
		player.pflags = $ |PF_THOKKED
		local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = player.mo.color
		ghost.colorized = true
		ghost.fuse = 15
		ghost.scale = player.mo.scale*3/2
		S_StartSound(player.mo, sfx_s3kb3)
		player.mo.state = S_PLAY_FALL
		P_InstaThrust(player.mo,player.mo.angle,5*FRACUNIT/10 + player.speed)
		player.camangle = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
		local gotox = player.mo.x+FixedMul(260*FRACUNIT/10, cos(player.camangle))
		local gotoy = player.mo.y+FixedMul(260*FRACUNIT/10, sin(player.camangle)) 
		//local gotoz = player.mo.z+FixedMul(1*FRACUNIT/3, sin(player.camangle)) 
		P_TeleportMove(player.mo, gotox, gotoy, player.mo.z)
		P_SetObjectMomZ(player.mo,0)
		local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = ColorOpposite(player.mo.color)
		ghost.colorized = true
		ghost.fuse = 15
		ghost.scale = player.mo.scale*3/2
	end
end)

addHook("MapLoad", function()
	if gamemap == 16
		P_SetupLevelSky(35)
		P_SwitchWeather(PRECIP_STORM)
	end
end)

//Classic spindash behavior by rumia1!
addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.valid
		and not (player.mo.state == S_PLAY_DEAD)
			if(player.mo.skin == "stealth")
			//setting up the variable to check for how many charges the current spindash has
				if player.spincharges == nil
					player.spincharges = 0
				end
			//this one checks how long the spindash has been held for
				if player.dashtime == nil
				or not (player.pflags & PF_STARTDASH)
					player.dashtime = 15
				end
			//and this one checks how many automatic charges we've added, as we can only have 4
				if player.dashcounter == nil
				or not (player.pflags & PF_STARTDASH)
					player.dashcounter = 0
				end
			//checks if player was holding jump last frame
				if player.jumpwasdown == nil
					player.jumpwasdown = 0
				end
				
				if player.forwardwasdown == nil
					player.forwardwasdown = 0
				end
				if player.backwasdown == nil
					player.backwasdown = 0
				end
				if player.leftwasdown == nil
					player.leftwasdown = 0
				end
				if player.rightwasdown == nil
					player.rightwasdown = 0
				end
				
			//makes our life easier
 				if player.pflags & PF_STARTDASH
 					player.dashspeed = player.maxdash
 					player.mindash = player.maxdash - (21*player.dashspeed)
 				end
		
				if player.dashcounter >= 3
					player.dashcounter = 3
				end
				if player.dashtime <= 0
					player.dashtime = 15
				end
				if testing == true then print(player.dashcounter, player.dashtime, player.dashspeed/FRACUNIT, player.spincharges) end
				if (player.pflags & PF_STARTDASH)
					player.jumpfactor = 0
					player.dashtime = $ - 1
					if player.spincharges == 0
						player.mindash = 23*FRACUNIT
						player.maxdash = 25*FRACUNIT
						player.mindash = player.maxdash - (21*player.dashspeed)
					else
						player.maxdash = (25*FRACUNIT) + (player.spincharges*(5*FRACUNIT))
					end
					if (player.cmd.forwardmove >= 25)
					and not (player.forwardwasdown)
					or (player.cmd.forwardmove <= -25)
					and not (player.backwasdown)
					or (player.cmd.sidemove >= 25)
					and not (player.rightwasdown)
					or (player.cmd.sidemove <= -25)
					and not (player.leftwasdown)
					or (player.cmd.buttons & BT_JUMP)
					and not (player.jumpwasdown)
						if player.spincharges < 15
							player.spincharges = $ + 1
						else
							player.spincharges = 15
						end
						S_StopSound(player.mo)
						S_StartSound(player.mo, 478 + player.spincharges)
					end

				else
					player.jumpfactor = skins[player.mo.skin].jumpfactor
					player.spincharges = 0
				end
			//Our "was jump pressed last frame?" check ends here
				player.jumpwasdown = (player.cmd.buttons & BT_JUMP)
				if (player.cmd.forwardmove >= 25)
					player.forwardwasdown = 1
				else
					player.forwardwasdown = 0
				end
				if (player.cmd.forwardmove <= -25)
					player.backwasdown = 1
				else
					player.backwasdown = 0
				end
				if (player.cmd.sidemove >= 25)
					player.rightwasdown = 1
				else
					player.rightwasdown = 0
				end
				if (player.cmd.sidemove <= -25)
					player.leftwasdown = 1
				else
					player.leftwasdown = 0
				end
			end
		end
	end
end)
